#!/bin/bash

#db call to get database name

PSQL="/usr/bin/psql"
pushd `dirname $0`

install_stats () {
	$PSQL -d $i -c "\i sql/pgstatspack_create_tables.sql"
	$PSQL -d $i -c "\i sql/pgstatspack_create_snap.sql"
	$PSQL -d $i -c "\i sql/pgstatspack_delete_old_stats.sql"
}

update_stats () {
	$PSQL -d $i -c "\i sql/pgstatspack_upgrade_tables.sql"
	$PSQL -d $i -c "\i sql/pgstatspack_create_snap.sql"
}

for i in `$PSQL -t -c "\i sql/db_name.sql"`
do
	echo "Results for database $i"
	if [ `$PSQL -d $i -t -c "select count(lanname) from pg_language where lanname='plpgsql';"` -lt 1 ]
	then 
		echo "Installing language plpgsql for database $i"
		$PSQL -d $i -c "create language plpgsql;"	
	fi
	x=`$PSQL -t  -d $i -c "\i sql/pgstats_exist.sql"`
	if [ $x -eq "0" ]
	then
		echo "Installing Statistics Package for database $i"
		install_stats
	elif [ $x -lt "6" ]
	then
		echo "Previous install of statisics package was incomplete. Reinstalling Stats for database $i"
		install_stats
	else
		echo "Statistics package already exists for database: $i "
		echo "Updating stored functions"
		update_stats
	fi
	x=0
	echo ""
done 
popd
